import 'dart:async';

import 'package:flutter/material.dart';

/// This class is generated by flappy_translator package
/// You should never change something directly in this file but, instead, generate new file when needed with the package
class I18n {
  String get appTitle => _getText("appTitle");

  String description({String name,}) {
    String text = _getText("description");
    if (name != null) {
      text = text.replaceAll("%name\$s", name);
    }
    return text;
  }

  String get ok => _getText("ok");

  I18n(Locale locale) {
    this._locale = locale;
    _localizedValues = null;
  }

  Locale _locale;

  static Map<String, String> _localizedValues;

  static Map<String, String> _frValues = {
    "appTitle": "Un super titre",
    "description": "Une descritpion avec une variable : %name\$s",
    "ok": "ok",
  };

  static Map<String, String> _enValues = {
    "appTitle": "An awesome title",
    "description": "A descritpion with a variable : %name\$s",
    "ok": "ok",
  };
  static Map<String, Map<String, String>> _allValues = {
    "fr": _frValues,
    "en": _enValues,
  };

  static I18n of(BuildContext context) {
    return Localizations.of<I18n>(context, I18n);
  }

  String _getText(String key) {
    return _localizedValues[key] ?? '** $key not found';
  }

  static Future<I18n> load(Locale locale) async {
    I18n translations = new I18n(locale);
    _localizedValues = _allValues[locale.languageCode];
    return translations;
  }

  get currentLanguage => _locale.languageCode;
}

class I18nDelegate extends LocalizationsDelegate<I18n> {
  const I18nDelegate();

  @override
  bool isSupported(Locale locale) => ['fr', 'en'].contains(locale.languageCode);

  @override
  Future<I18n> load(Locale locale) => I18n.load(locale);

  @override
  bool shouldReload(I18nDelegate old) => false;
}
